function [dw, db] = bpReLU(z, w, m, t)
h = length(m) - 2;
ny = m(h+2);        % Number of Classes
y = z(h+2,(1:ny));  % actual output
dw = zeros(size(w));% derivatives of all weights
db = zeros(h+1, max(m));

db(h+1, 1:m(h+2)) = (y>0) .* (y-t);
for j=1:m(h+2)
    dw(h+1, (1:m(h+1)), j) = z(h+1, (1:m(h+1))) * db(h+1, j);
end

for l=h:-1:1
    for j=1:m(l+1)
        tmp = reshape(w(l+1,j,(1:m(l+2))), [1,m(l+2)]);
        db(l,j) = (z(l+1,j)>0) * sum(db(l+1,(1:m(l+2))) .* tmp);
        dw(l,(1:m(l)),j) = z(l,(1:m(l))) * db(l,j);
    end
end