function y = polation(x, h, w)
[m,n] = size(x);
y = zeros(h,w); % desired output
for i=1:h
    ylb = min(m, max(1, floor((i-0.5)*m/h)));
    yub = min(m, max(1, ceil((i+0.5)*m/h)));
    for j=1:w
        xlb = min(n, max(1, floor((j-0.5)*n/w)));
        xub = min(n, max(1, ceil((j+0.5)*n/w)));
        y(i,j) = 0;
        for yk=ylb:yub
            for xk=xlb:xub
                y(i,j) = y(i,j) + x(yk,xk);
            end
        end
        y(i,j) = y(i,j)/((yub-ylb+1)*(xub-xlb+1));
    end
end