function y = encodeCNN2(x, k, b)
% y: output
% x: input
% k: kernel
% b: bias

[mx, nx] = size(x); % size of input
[mk, nk] = size(k); % size of kernel
my = mx - mk + 1;
ny = nx - nk + 1;   % size of output
y = zeros(my, ny);
for i=1:my
    for j=1:ny
        y(i,j) = sum(sum(k .* x(i:(i+mk-1), j:(j+nk-1)))) + b(i,j);
    end
end
